Debian Bug report logs - #397121
unnecessary dpkg accesses to the available file

version graph

Package: dpkg; Maintainer for dpkg is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg is src:dpkg.

Reported by: Michel Lespinasse <walken@zoy.org>

Date: Sun, 5 Nov 2006 11:03:17 UTC

Severity: normal

Tags: patch

Found in version dpkg/1.13.24

Fixed in version dpkg/1.16.0

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#397121; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Michel Lespinasse <walken@zoy.org>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Michel Lespinasse <walken@zoy.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: unnecessary dpkg accesses to the available file
Date: Sun, 5 Nov 2006 02:55:58 -0800
[Message part 1 (text/plain, inline)]
Package: dpkg
Version: 1.13.24
Severity: normal

As reported under bug 395140, dpkg/dselect takes a lot of memory and
can easily push low-memory systems to swap. Most of this memory usage
is related to parsing the available file into an in-memory database.

I mentionned this issue to Matt Zimmerman and he made the following
observation:
> The fact that dpkg pays attention to the available file at all is a bug;
> it should only care about the state of the system and not about external
> repositories.  Only higher level package managers like apt and dselect
> should do that.

I think he's correct, in that dpkg only needs to consider dependencies or
conflicts with the installed packages on the system, and can safely ignore
anything that has not been installed. Any other behaviour is at best
undocumented, and most likely, a bug.

In detail, here is what I suggest:

dpkg --install / --unpack / --configure / --remove / --purge currently read
and write the available file, they need not touch it at all.

dpkg --get-selections / --set-selections / --clear-selections / --audit /
 --yet-to-unpack should not need to touch the available file either, I think.

dpkg-query should never read or write the available file except for the
--print-avail command.


The commands that write to the available file should be limited to:
dpkg --record-avail
dpkg --update-avail / --merge-avail / --clear-avail
(any writes to the available file will be lost at the next dselect update
anyway, but dpkg --update-avail needs to work for dselect update to work).

The commands that read the available file should be limited to:
dselect select (reads and rewrites today)
dpkg-query --print-avail (already done readonly today)
dpkg --forget-old-unavail (reads and rewrites today)
dpkg --predep-package (already done readonly today)


The attached patch implements this suggestion.

-- 
Michel "Walken" Lespinasse
"Bill Gates is a monocle and a Persian cat away from being the villain
in a James Bond movie." -- Dennis Miller
[dpkg4.diff (text/plain, attachment)]

Tags added: patch Request was from Michel Lespinasse <walken@zoy.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#397121; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <iwj@ubuntu.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #12 received at 397121@bugs.debian.org (full text, mbox):

From: Ian Jackson <iwj@ubuntu.com>
To: 397121@bugs.debian.org
Subject: dpkg and the available file
Date: Tue, 10 Apr 2007 17:40:07 +0100
dpkg internally uses the available version to distinguish the version
that is proposed to be installed (with dpkg -i or --unpack) from the
version currently present.  Originally it seemed appropriate that the
available information shown (eg) in dselect would be updated during
this operation as well.

But I think that this has now outlived its time, even if it was ever
right.  So it is fine to make dpkg not read or write the available
file.  It will still obviously update its internal `available' data
during installation but this won't ever end up on disk.

I have eyeballed the patch and it doesn't look unreasonable, although
if there is any doubt it would be best to check the context for each
of those patch hunks since it's not clear from just the patch whether
each change is correct.

Also, we should note that after this change the `available' in-memory
data facility from the lib/* files in dpkg is used for quite different
purposes by dpkg and dselect.  This may be confusing but is best left
alone I think.

I hope you find these comments helpful :-).

Regards,
Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#397121; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #17 received at 397121@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Michel Lespinasse <walken@zoy.org>, 397121@bugs.debian.org
Subject: Re: Bug#397121: unnecessary dpkg accesses to the available file
Date: Sun, 6 Jul 2008 18:39:32 +0300
Hi,

On Sun, 2006-11-05 at 02:55:58 -0800, Michel Lespinasse wrote:
> Package: dpkg
> Version: 1.13.24
> Severity: normal

> As reported under bug 395140, dpkg/dselect takes a lot of memory and
> can easily push low-memory systems to swap. Most of this memory usage
> is related to parsing the available file into an in-memory database.
> 
> I mentionned this issue to Matt Zimmerman and he made the following
> observation:
> > The fact that dpkg pays attention to the available file at all is a bug;
> > it should only care about the state of the system and not about external
> > repositories.  Only higher level package managers like apt and dselect
> > should do that.
> 
> I think he's correct, in that dpkg only needs to consider dependencies or
> conflicts with the installed packages on the system, and can safely ignore
> anything that has not been installed. Any other behaviour is at best
> undocumented, and most likely, a bug.

The only problem I see with this is that then dpkg will ignore
completely any override from the archive, which most of the time is
not really important as they affect stuff not used by dpkg for the
dependency resolution as you said.

The only important information might be the Section and Priority fields,
which are usually overriden and used to create roostraps or select what's
the base system, etc. But on the other hand I think all programs doing
that are using the archive Packages files for that purpose, so I guess
it's fine to apply this patch.

> In detail, here is what I suggest:
> 
> dpkg --install / --unpack / --configure / --remove / --purge currently read
> and write the available file, they need not touch it at all.
> 
> dpkg --get-selections / --set-selections / --clear-selections / --audit /
>  --yet-to-unpack should not need to touch the available file either, I think.
> 
> dpkg-query should never read or write the available file except for the
> --print-avail command.
> 
> 
> The commands that write to the available file should be limited to:
> dpkg --record-avail
> dpkg --update-avail / --merge-avail / --clear-avail
> (any writes to the available file will be lost at the next dselect update
> anyway, but dpkg --update-avail needs to work for dselect update to work).
> 
> The commands that read the available file should be limited to:
> dselect select (reads and rewrites today)
> dpkg-query --print-avail (already done readonly today)
> dpkg --forget-old-unavail (reads and rewrites today)
> dpkg --predep-package (already done readonly today)

Yeah seems reasonable, will review and merge.

thanks,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#397121; Package dpkg. (Thu, 19 Feb 2009 15:12:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julian Gilbey <jdg@polya.uklinux.net>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 19 Feb 2009 15:12:06 GMT) Full text and rfc822 format available.

Message #22 received at 397121@bugs.debian.org (full text, mbox):

From: Julian Gilbey <jdg@polya.uklinux.net>
To: Guillem Jover <guillem@debian.org>, 397121@bugs.debian.org
Subject: Re: Bug#397121: unnecessary dpkg accesses to the available file
Date: Thu, 19 Feb 2009 15:10:01 +0000
On Sun, Jul 06, 2008 at 06:39:32PM +0300, Guillem Jover wrote:
> Hi,
> [...]
> > > The fact that dpkg pays attention to the available file at all is a bug;
> > > it should only care about the state of the system and not about external
> > > repositories.  Only higher level package managers like apt and dselect
> > > should do that.
> [...]
> The only important information might be the Section and Priority fields,
> which are usually overriden and used to create roostraps or select what's
> the base system, etc. But on the other hand I think all programs doing
> that are using the archive Packages files for that purpose, so I guess
> it's fine to apply this patch.
> [...]
> 
> Yeah seems reasonable, will review and merge.

Please could you do this?  I have frequently had problems where dpkg
seems to have corrupted the available database (as reported by someone
else in bug#303030); if dpkg does not look at this database, then such
problems can be avoided.  (The source of bug#303030 is a separate
matter entirely, though.)

   Julian




Added tag(s) pending. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Mon, 14 Mar 2011 06:33:07 GMT) Full text and rfc822 format available.

Message sent on to Michel Lespinasse <walken@zoy.org>:
Bug#397121. (Mon, 14 Mar 2011 06:33:09 GMT) Full text and rfc822 format available.

Message #27 received at 397121-submitter@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 397121-submitter@bugs.debian.org
Subject: Bug#397121 marked as pending
Date: Mon, 14 Mar 2011 06:31:06 +0000
tag 397121 pending
thanks

Hello,

Bug #397121 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=fb49e13

---
commit fb49e131ef32039277c538f759ab19c1ff22e8fd
Author: Guillem Jover <guillem@debian.org>
Date:   Fri Mar 4 16:15:51 2011 +0100

    Do not read the available file unnecessarily
    
    For commands that only make use of information from the status file,
    there's no need to make them read and parse the available file. This
    change does not alter the current behaviour, and commands that were
    previously updating the available file will continue doing so.
    
    Removing further access to it is pending a decision on how to treat
    globally the available file, which needs interaction with the package
    manager frontend developers.
    
    Closes: #397121
    
    Based-on-patch-by: Michel Lespinasse <walken@zoy.org>

diff --git a/debian/changelog b/debian/changelog
index e586bdd..e367a74 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -41,6 +41,8 @@ dpkg (1.16.0) UNRELEASED; urgency=low
     instead of the last file acted on that directory.
   * Document in dpkg-query --help output and man page that --list and --show
     arguments are optionsl.
+  * Do not read the available file unnecessarily.
+    Thanks to Michel Lespinasse <walken@zoy.org>. Closes: #397121
 
   [ Raphaël Hertzog ]
   * Fail properly when debian/source/format is empty. Closes: #600854




Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Sat, 02 Apr 2011 04:21:05 GMT) Full text and rfc822 format available.

Notification sent to Michel Lespinasse <walken@zoy.org>:
Bug acknowledged by developer. (Sat, 02 Apr 2011 04:21:05 GMT) Full text and rfc822 format available.

Message #32 received at 397121-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 397121-close@bugs.debian.org
Subject: Bug#397121: fixed in dpkg 1.16.0
Date: Sat, 02 Apr 2011 04:17:19 +0000
Source: dpkg
Source-Version: 1.16.0

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.16.0_all.deb
  to main/d/dpkg/dpkg-dev_1.16.0_all.deb
dpkg_1.16.0.dsc
  to main/d/dpkg/dpkg_1.16.0.dsc
dpkg_1.16.0.tar.bz2
  to main/d/dpkg/dpkg_1.16.0.tar.bz2
dpkg_1.16.0_amd64.deb
  to main/d/dpkg/dpkg_1.16.0_amd64.deb
dselect_1.16.0_amd64.deb
  to main/d/dpkg/dselect_1.16.0_amd64.deb
libdpkg-dev_1.16.0_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.16.0_amd64.deb
libdpkg-perl_1.16.0_all.deb
  to main/d/dpkg/libdpkg-perl_1.16.0_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 397121@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 01 Apr 2011 23:56:54 +0200
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.16.0
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 31141 97076 397121 476335 483119 591858 594179 596841 598922 600854 604914 605719 606080 608829 611741 612203 612465 612472 613023 616096 616502 617923 619311 619541 620380
Changes: 
 dpkg (1.16.0) unstable; urgency=low
 .
   [ Guillem Jover ]
   * Use DPKG_MAINTSCRIPT_PACKAGE environment variable as package name on
     dpkg-divert when no --package or --local options have been specified.
   * Do not allow versions starting with non-digit when doing strict parsing,
     warn otherwise.
   * Update dpkg(1) to note that --status-fd output does not contain newlines
     in error messages anymore (this was fixed in 1.15.0).
   * Add a new --status-logger option to dpkg, similar to --status-fd but
     instead invoke the command ourselves and feed the status information
     to its standard input. Suggested by Raphaël Hertzog.
   * Add missing space in update-alternative --set-selections output.
   * Add missing options to update-alternative --help output.
   * Count “conffile name is duplicated” for dpkg-deb warning count summary.
   * Improve and clarify strings for translation. Closes: #604914
   * Prefix all fatal error messages with “error: ”.
   * Do not check presence of update-rc.d in the PATH in dpkg, as it's not
     a program needed for dpkg correct operation.
   * Fix dpkg -GEO options on multiple versions of the same packages.
     Closes: #31141
   * Propagate --admindir to programs run from maintainer scritpts.
     Closes: #97076
   * Do not fail when trying to remove the root directory. This will only
     happen either on distributions where dpkg is a foreign package manager,
     or on artificial dpkg databases.
   * Always warn when parsing any package control data which does not have
     an Architecture field except for status and status log files when
     packages are not-installed or half-installed.
   * By default reject installing packages w/o an Architecture field. They
     now need --force-architecture, dpkg will still warn about them though.
   * Fix build failure when passing --disable-nls to configure.
   * Do not segfault on “dpkg -i --no-act”.
   * Add missing semicolon to the vsnprintf() compat declaration.
     Thanks to Robert Millan. Closes: #612203
   * On install for Ubuntu adjust the i386 GNU cpu name in cputable.
     Thanks to Colin Watson <cjwatson@ubuntu.com>. Closes: #611741
   * Sync the info database directory on unpack instead of the temporary
     control information directory, and print the correct pathname on error
     instead of the last file acted on that directory.
   * Document in dpkg-query --help output and man page that --list and --show
     arguments are optional.
   * Do not read and write the available file unnecessarily.
     Thanks to Michel Lespinasse <walken@zoy.org>. Closes: #397121
   * Fix typo in «dpkg-name --overwrite» argument parsing so that it actually
     works at all. Thanks to Ivan Gagis <igagis@gmail.com>. LP: #728708
   * Add armhf support to ostable and triplettable. Closes: #594179
   * Set the modification time for unpacked symlinks on supported systems.
   * Fix undefined value useage in dpkg-genchanges when adding files w/o a
     matching architecture, because they are not present in debian/control,
     this is most commonly the case due to dpkg-distaddfile.
   * Terminate immediately on dpkg-divert rename errors instead of propagating
     up the error codes, this improves error reporting and avoids triggering
     leak detectors. Closes: #620380
   * When moving a diverted file across filesystems in dpkg-divert, remove
     the source file.
 .
   [ Raphaël Hertzog ]
   * Fail properly when debian/source/format is empty. Closes: #600854
   * Add new deb-src-control(5) manual page documenting the debian/control
     file contained in source packages.
     - it documents the X[SBC]- prefix. Closes: #476335
     - it documents the VCS-* fields too. Closes: #483119
     Thanks to Oxan van Leeuwen <oxan@oxanvanleeuwen.nl> who wrote it
     as part of the Google Code In program.
   * Enhance dpkg-shlibdeps to not fail immediatly when a library is not found.
     Instead continue and fail after all problems have been reported. Thanks
     to Chris Baines <cbaines8@gmail.com> for the patch. Closes: #596841
   * Fix dpkg-source to not list Debian packaging files as modified
     upstream files in Format "1.0" when unpacking to a non-standard
     directory.
   * Apply patch from Colin Watson to let dpkg-buildflags return -O3
     instead of -O2 when building ppc64 packages on Ubuntu. Closes: #612472
   * Add new function get_control_path() to Dpkg::Path, it wraps dpkg-query
     --control-path.
   * Update dpkg-shlibdeps to be multiarch-ready:
     - use get_control_path() to find symbols/shlibs files
     - parse correctly the output of dpkg --search
   * Small fix to support files >2GB in .deb on 64-bit systems. Closes: #616502
     Thanks to Martin Dorey <mdorey@bluearc.com> for the patch.
   * dpkg-source now keeps the file ordering in the autogenerated patch when
     regenerating it. Closes: #606080
     Thanks to Colin Watson for the patch.
   * dpkg-source now uses a timestamp retrieved from the filesystem when
     resetting the timestamp of patched files so that a time skew when using
     NFS doesn't introduce any inconsistency. Closes: #613023
     Thanks to Jonathan Nieder <jrnieder@gmail.com> for the patch and the
     diagnosis.
   * dpkg-source will now remove quilt's .pc directory when --unapply-patches
     is in use. Closes: #591858
   * dpkg-source is now a bit less strict when parsing patches:
     - it accepts seeing the same file twice; Closes: #608829
     - it doesn't match on the English text "No newline at end of file" as it
       might be translated in some cases. Closes: #612465
   * Improve parser in Dpkg::Control::Hash to not require an empty line
     before the PGP signature. Closes: #617923
     Thanks to Roger Leigh for the initial patch.
   * Fix a regression in dpkg-divert where using --rename led to a failure when
     the rename implies crossing file systems. Thanks to Durk Strooisma for
     spotting it.
   * Use the correct mtime when installing a file with statoverrides.
     Regression introduced in 1.16.0. LP: #739179
   * Remove duplicate word in german translation of dpkg(1). Closes: #616096
   * Strip repeated non-significant spaces before and after newlines
     in Uploaders. Closes: #598922
   * Ignore whitespaces after options in headers of changelog entries.
     Closes: #605719
   * Fix dpkg-source's regression with empty patches (introduced while fixing
     #613023). Closes: #619541
 .
   [ Jonathan Nieder ]
   * Remove support for use of synchronous sync(2), due to its pernicious
     side-effects and to ease maintenance.
   * Clarify that an up-to-date dpkg only needs to be unpacked for
     dpkg-maintscript-helper to work.
 .
   [ Steve Langasek ]
   * Add new variables to dpkg-architecture, DEB_HOST_MULTIARCH and
     DEB_BUILD_MULTIARCH, that return the "ideal" GNU triplet for each
     architecture which should be used as the path component for library
     installation.
 .
   [ Mark Hymers ]
   * Add support for Built-Using field. Closes: #619311
 .
   [ Updated programs translations ]
   * German (Sven Joachim).
   * Portuguese (Miguel Figueiredo).
   * Spanish (Javier Fernandez-Sanguino).
   * Swedish (Peter Krefting).
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
 .
   [ Updated scripts translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
 .
   [ Updated dselect translations ]
   * Spanish (Javier Fernandez-Sanguino).
Checksums-Sha1: 
 ce2157f0050ae5307c0b3f867219e90eccea417f 1200 dpkg_1.16.0.dsc
 c5588cfa254ff0d698fc1eb7d9d11be9da235371 5321098 dpkg_1.16.0.tar.bz2
 68d767846ee0bd9a20d627ef3371c2c98c12e066 494608 libdpkg-dev_1.16.0_amd64.deb
 239a3d17163706530443fb847bb61703ac6e0c00 2230440 dpkg_1.16.0_amd64.deb
 59ad8d6ca4573c2bb85861472c9437ed23a0e77c 948708 dselect_1.16.0_amd64.deb
 64c9a96eb3caaf34d1d14f09c5c81c4826539da6 870310 dpkg-dev_1.16.0_all.deb
 24c2b86c3cb1867ae4ddf1e3c1a631ca73b8fe0d 746970 libdpkg-perl_1.16.0_all.deb
Checksums-Sha256: 
 dc45d4c80599fb4fb377caf497c003ef5fef8e1fcf0b0cba51bae457041c2554 1200 dpkg_1.16.0.dsc
 2536bd1493ba5de8d0914c30d6b83d4390013caa98580bd33a735cebe445004a 5321098 dpkg_1.16.0.tar.bz2
 1e1e7e02834b554932aa0b7ef48b3b2e982893011f7261629f19882a0271a1b3 494608 libdpkg-dev_1.16.0_amd64.deb
 0f7858e704d1e0dd8f7195921cb29d6e296ff71e4568cf6a99c9a89a62907670 2230440 dpkg_1.16.0_amd64.deb
 e068fa295a74e769407ab9230208a20c3385c9f978d130077a0a5b506e66e14b 948708 dselect_1.16.0_amd64.deb
 54603f6285f06b8f805394ed63c63aad3671e66c9385818361a89190ced55972 870310 dpkg-dev_1.16.0_all.deb
 10aa393491951ac72f6d8429974e7be5c62b52fbb10fe8437fceb274ce8a2b1c 746970 libdpkg-perl_1.16.0_all.deb
Files: 
 8aaddcf28fe29848e0839e4f49aa5b27 1200 admin required dpkg_1.16.0.dsc
 dc83fe7c1346a2a7bf78548306447c1d 5321098 admin required dpkg_1.16.0.tar.bz2
 700983a5d39442c66f07403f13afc3bb 494608 libdevel optional libdpkg-dev_1.16.0_amd64.deb
 7a243ebcc1618a0b7a1054c510459191 2230440 admin required dpkg_1.16.0_amd64.deb
 433d60711295f8c311c85a9d31020ac1 948708 admin optional dselect_1.16.0_amd64.deb
 6a049c453a6370cab4e0a8611ed0153e 870310 utils optional dpkg-dev_1.16.0_all.deb
 86124110a1596fddc34fff8fc29a15e8 746970 perl optional libdpkg-perl_1.16.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk2WnHUACgkQuW9ciZ2SjJvVoQCdEWDb2Bi1NhycZk3sZ1Ak7ARE
kR4AoPHbIFD2mzngex1DGcFIKQ1CRXaH
=QKGg
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 17 May 2011 07:40:08 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 15:00:08 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.